var baseurl = "http://resolver.library.ualberta.ca/resolver"; // base url of the link resolver (no ? at end)
var button = "http://resolver.library.ualberta.ca/resolver-templates/gifs/getit.gif";
var sid = "ualberta:googlescholaropenurl";
var alttext = "Get It!"; // for alt attribute for button

function insertOpenurls() {

	var document = window._content.document; 
	if (document.location.href.indexOf("scholar.google.") != -1) {
	// this is a Google Scholar page

		// work through the hits, each of which is in a p element
		var hits = document.getElementsByTagName("p");
		for (var i = 0; i < hits.length; i++) {
			var p = hits[i];
			
			// get article title out of the link (if any)
			// link is in span tag with class=w
			var spans = p.getElementsByTagName("span");
			// if there is no span, there's no title link, so we don't want an openurl
			if (spans.length) {
				// grab the contents of the first a in the first span, and strip tags
				// (since the search term is in b tags)
				var atitle = spans[0].getElementsByTagName("a")[0].innerHTML.replace(/(<([^>]+)>)/ig,"");
			
				// now let's get the author from the first green font bit
				var j = 0;
				var fonttags = p.getElementsByTagName("font");
				var author = "";
				while (author == "") {
					if (fonttags[j].getAttribute("color") == 'green') {
						author = fonttags[j].innerHTML;			
					}
					else 
						j++;
				}
				// reduce to first author by truncating at comma
				j = author.indexOf(',');
				if (j >= 0) {
					author = author.substring(0, j);
				}
				// now separate the initials
				j = author.indexOf(' ');
				var init = "";
				if (j >= 0) {
					init = author.substring(0, j);
					author = author.substring(j + 1, author.length);
				} 

			
				// first, we need to retrieve the last green font tag
				// we grab the content of each green font tag in turn, so that 
				// each one replaces the last one - so we'll be left with the 
				// contents of the final one
				var citation = "";
				for (j = 0; j < fonttags.length; j++) {
					// we want green font tags that are direct children of a font tag
					if ((fonttags[j].getAttribute("color") == 'green') && 
					 (fonttags[j].parentNode.nodeName == 'FONT')) {
					// get value of first node - if we're in the last green font tag, 
					// the first child must be the text before the links
						citation = fonttags[j].childNodes[0].nodeValue;
					}
				} // end fonttags loop

				// now parse the citation
				// remove everything after the -
				j = citation.indexOf('-');
				if (j >= 0)
					citation = citation.substring(0, j-1);			
				// now grab the year
				j = citation.indexOf(',');
				var year = "";
				if (j >= 0) {
					year = citation.substring(j+2, j+6);
					citation = citation.substring(0, j);
				}
				// now build the openurl
				openurl = "sid=" + sid + "&genre=article&title=" + escape(citation);
				if (year != "")
					openurl += "&date=" + year;
				openurl += "&atitle=" + escape(atitle); 
				if (author != "")
					openurl += "&aulast=" + author + "&auinit=" + init;

				// finally, build the link	
				var openurllink = document.createElement("a");
  	    openurllink.setAttribute("href", baseurl + '?' + openurl);
  			openurllink.setAttribute("target", '_new');
	    	openurllink.innerHTML = "<img style='border: 0px;'  src='" + button + 
					"' alt='" + alttext +"'>";
				p.appendChild(document.createElement("br"));
  	    p.appendChild(openurllink);		
			} // end "if spans"
		} // end hits loop
	}// end "if scholar.google"
}

// create the listener that will run insertOpenurls() on load
window.addEventListener("load", function() {insertOpenurls();}, true);
